using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

using System.IO;

namespace JacekMatulewski.Util
{
	/// <summary>
	/// Lists the content of the specified directory. Allows to explore the drives and strongly supports drag and drop process..
	/// </summary>
	public class FileListBox : System.Windows.Forms.UserControl
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ListBox listBox1;

		#region Pola prywatne
		//wewnetrzne
		private string[] listaKatalogow=null;
		private string[] listaPlikow=null;
		private string[] listaDyskow=null;
		private bool pokazujDwieKropki=true;
		private FileSystemWatcher wartownik=null;
		//konfigurowanie komponentu
		private string sciezkaKatalogu=null;
		private bool uwzglednijKatalogi=true;
		private bool uwzglednijPliki=true;
		private bool uwzglednijDyski=true;
		private bool uwzglednijKatalogNadrzedny=true;
		private string filtr=null;
		private bool mozliweZmienianieKatalogow=true;
		#endregion

		#region Metody prywatne
		private void PobierzZawartoscKatalogu()
		{
			if (sciezkaKatalogu==null)
				sciezkaKatalogu=Directory.GetCurrentDirectory();

			if (!Directory.Exists(sciezkaKatalogu))
				throw new Exception("Katalog "+sciezkaKatalogu+" nie istnieje!");

			pokazujDwieKropki=(sciezkaKatalogu!=Path.GetPathRoot(sciezkaKatalogu) && uwzglednijKatalogNadrzedny);

			listBox1.Items.Clear();

			if (uwzglednijKatalogi)
				{
				if (pokazujDwieKropki) listBox1.Items.Add("[..]");
				listaKatalogow=Directory.GetDirectories(sciezkaKatalogu);
				Array.Sort(listaKatalogow);
				//listBox1.Items.AddRange(listaKatalogow);
				//for (int i=0;i<listaKatalogow.Length;i++)
					//listBox1.Items.Add("["+Path.GetFileName(listaKatalogow[i])+"]");
				foreach (string katalog in listaKatalogow)
					listBox1.Items.Add("["+Path.GetFileName(katalog)+"]");
				}
			if (uwzglednijPliki)
				{
				listaPlikow=Directory.GetFiles(sciezkaKatalogu);
				if (filtr!=null) listaPlikow=Directory.GetFiles(sciezkaKatalogu,filtr);
				Array.Sort(listaPlikow);
				//listBox1.Items.AddRange(listaPlikow);
				//for (int i=0;i<listaPlikow.Length;i++)
					//listBox1.Items.Add(Path.GetFileName(listaPlikow[i]));
				foreach (string plik in listaPlikow)
					listBox1.Items.Add(Path.GetFileName(plik));
				}
			if (uwzglednijDyski)
				{
				listaDyskow=Directory.GetLogicalDrives();
				//listBox1.Items.AddRange(listaDyskow);
				foreach (string dysk in listaDyskow)
					listBox1.Items.Add("<"+dysk.Substring(0,2)+">");

				}
		}
		#endregion


		/// <summary>
		/// Creates new instance of <b>FileListBox</b>.
		/// </summary>
		public FileListBox()
		{
			// This call is required by the Windows.Forms Designer.
			InitializeComponent();
			//
			PobierzZawartoscKatalogu();
			UstawWartownika();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
					components.Dispose();
			}
			base.Dispose(disposing);
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// listBox1
			// 
			this.listBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listBox1.ItemHeight = 16;
			this.listBox1.Location = new System.Drawing.Point(0, 0);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(150, 148);
			this.listBox1.TabIndex = 0;
			this.listBox1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.listBox1_KeyDown);
			this.listBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseDown);
			this.listBox1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.listBox1_KeyPress);
			this.listBox1.DoubleClick += new System.EventHandler(this.listBox1_DoubleClick);
			this.listBox1.MouseHover += new System.EventHandler(this.listBox1_MouseHover);
			this.listBox1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.listBox1_KeyUp);
			this.listBox1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseUp);
			this.listBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.listBox1_MouseMove);
			this.listBox1.MouseEnter += new System.EventHandler(this.listBox1_MouseEnter);
			this.listBox1.MouseLeave += new System.EventHandler(this.listBox1_MouseLeave);
			this.listBox1.SelectedIndexChanged += new System.EventHandler(this.listBox1_SelectedIndexChanged);
			// 
			// FileListBox
			//
			this.Controls.Add(this.listBox1);
			this.Name = "FileListBox";
			this.ResumeLayout(false);
		}
		#endregion

		private void listBox1_DoubleClick(object sender, System.EventArgs e)
		{
			//przekazanie zdarzenia DoubleClick
			this.OnDoubleClick(e);

			//wywolanie zdarzenia FileDoubleClick jezeli klikniety jest plik
			int przesuniecie=(pokazujDwieKropki && uwzglednijKatalogi)?1:0;
			int numer=listBox1.SelectedIndex-przesuniecie; //+1 dla [..]
			int poczatekPlikow=(uwzglednijKatalogi?listaKatalogow.Length:0);
			int poczatekDyskow=poczatekPlikow+(uwzglednijPliki?listaPlikow.Length:0);

			//zmiana katalogu
			string nowaSciezkaKatalogu=null;
			if (numer==-1) nowaSciezkaKatalogu=sciezkaKatalogu+"\\..";
			if (numer>=0 && numer<poczatekPlikow) nowaSciezkaKatalogu=listaKatalogow[numer];
			if (numer>=poczatekDyskow) nowaSciezkaKatalogu=listaDyskow[numer-poczatekDyskow];
			if (nowaSciezkaKatalogu!=null && Directory.Exists(nowaSciezkaKatalogu) && mozliweZmienianieKatalogow)
				{
				sciezkaKatalogu=Path.GetFullPath(nowaSciezkaKatalogu);
				PobierzZawartoscKatalogu();
				this.OnDirectoryPathChanged(this,e);
				wartownik.Path=sciezkaKatalogu;
				}

			//podwojne klikniecie pliku
			string sciezkaPliku=null;
			if (numer>=poczatekPlikow && numer<poczatekDyskow) sciezkaPliku=listaPlikow[numer-poczatekPlikow];
			if (sciezkaPliku!=null && File.Exists(sciezkaPliku))
				this.OnFileDoubleClicked(this,e,Path.GetFullPath(sciezkaPliku));
		}

		#region Wlasnosci
		/// <summary>
		/// Gets or sets relative or absolute path of directory visible at component.
		/// </summary>
		/// <value>
		/// String containing the absolute value of displayed directory.
		/// </value>
		[
			Category("Directory"),
			Description("The DirectoryPath determines relative or absolute path of directory visible at component.")
		]
		public string DirectoryPath
		{
			set
			{
				this.sciezkaKatalogu = value;
				PobierzZawartoscKatalogu();
				this.OnDirectoryPathChanged(this,new System.EventArgs());
				wartownik.Path=sciezkaKatalogu;
			}
			get
			{
				return this.sciezkaKatalogu;
			}
		}

		/// <summary>
		/// Gets or sets the mask of possible file filter.
		/// </summary>
		/// <value>
		/// String containing the mask of the filter.
		/// </value>
		[
			Category("Directory"),
			Description("The Filter determines the mask of files in the list.")
		]
		public string Filter
		{
			set
			{
				this.filtr = value;
				PobierzZawartoscKatalogu();
			}
			get
			{
				return this.filtr;
			}
		}


		/// <summary>
		/// Determines if symbol of upper directory ".." should be displayed.
		/// </summary>
		/// <value>
		/// If values of <b>DoubleDotVisible</b> and <b>DirectoriesVisible</b> are <b>true</b> symbol of upper directory is displayed.
		/// </value>
		/// <seealso cref="DirectoriesVisible"></seealso>
		[
			Category("Directory"),
			Description("The DoubleDotVisible determines if symbol of upper directory should be displayed.")
		]
		public bool DoubleDotVisible
		{
			set
			{
				this.uwzglednijKatalogNadrzedny = value;
				PobierzZawartoscKatalogu();
			}
			get
			{
				return this.uwzglednijKatalogNadrzedny;
			}
		}

		/// <summary>
		/// Determines if list of directories should be displayed.
		/// </summary>
		/// <value>
		/// If value of <b>DirectoriesVisible</b> is true, subdirectories of displayed directory are shown.
		/// </value>
		[
			Category("Directory"),
			Description("The DirectoriesVisible determines if list of directories should be displayed.")
		]
		public bool DirectoriesVisible
		{
			set
			{
				this.uwzglednijKatalogi = value;
				PobierzZawartoscKatalogu();
			}
			get
			{
				return this.uwzglednijKatalogi;
			}
		}

		/// <summary>
		/// Determines if list of files should be displayed.
		/// </summary>
		/// <value>
		/// If value of <b>FilesVisible</b> is true, files in the displayed directory are shown.
		/// </value>
		[
			Category("Directory"),
			Description("The FilesVisible determines if list of files should be displayed.")
		]
		public bool FilesVisible
		{
			set
			{
				this.uwzglednijPliki = value;
				PobierzZawartoscKatalogu();
			}
			get
			{
				return this.uwzglednijPliki;
			}
		}

		/// <summary>
		/// Determines if list of drives aviable at the computer are displayed.
		/// </summary>
		/// <value>
		/// If value of <b>DrivesVisible</b> is true, drives are shown.
		/// </value>
		[
			Category("Directory"),
			Description("The DrivesVisible determines if list of drives should be displayed.")
		]
		public bool DrivesVisible
		{
			set
			{
				this.uwzglednijDyski = value;
				PobierzZawartoscKatalogu();
			}
			get
			{
				return this.uwzglednijDyski;
			}
		}

		/// <summary>
		/// Determines if user can change current directory by double-clicking on directory in the list.
		/// </summary>
		/// <remarks>
		/// Component allows exploring the aviable drives if value of this property is set to true. In other case only way to change the displayed property is to directly change value of <see cref="DirectoryPath">DirectoryPath</see> property.
		/// </remarks>
		/// <value>
		/// If value of <b>DirectoryChangeAllowed</b> is <b>true</b> the exploring of the drives is possible.
		/// </value>
		[
			Category("Directory"),
			Description("The DirectoryChangeAllowed determines if user can change current directory by double-clicking on directory in the list.")
		]
		public bool DirectoryChangeAllowed
		{
			set
			{
				mozliweZmienianieKatalogow = value;
			}
			get
			{
				return mozliweZmienianieKatalogow;
			}
		}

		/// <summary>
		/// Gets the full path and filename to selected item.
		/// </summary>
		/// <value>
		/// String containing the full path of selected file.
		/// </value>
		[
			Category("Directory"),
			Description("The FileName expose the full path and filename to selected item.")
		]
		public string FileName
		{
			get
			{
				int przesuniecie=(pokazujDwieKropki && uwzglednijKatalogi)?1:0;
				int numer=listBox1.SelectedIndex-przesuniecie; //+1 dla [..]
				int poczatekPlikow=(uwzglednijKatalogi?listaKatalogow.Length:0);
				int poczatekDyskow=poczatekPlikow+(uwzglednijPliki?listaPlikow.Length:0);

				string pelnaSciezka=null; //ta wartosc zostanie gdy brak zaznaczonego elementu
				if (numer==-1 && przesuniecie==1) pelnaSciezka=sciezkaKatalogu+"\\..";
				if (numer>=0 && numer<poczatekPlikow) pelnaSciezka=listaKatalogow[numer];
				if (numer>=poczatekPlikow && numer<poczatekDyskow) pelnaSciezka=listaPlikow[numer-poczatekPlikow];
				if (numer>=poczatekDyskow) pelnaSciezka=listaDyskow[numer-poczatekDyskow];

				if (pelnaSciezka==null) return "";

				return Path.GetFullPath(pelnaSciezka);
			}
		}

		/// <summary>
		/// Determines if files and subdirectories list is automatically uptadated.
		/// </summary>
		/// <value>
		/// If value of <b>DirectoryWatchingEnabled</b> is <b>true</b> component updates its contents after changes in the displayed directory.
		/// </value>
		[
			Category("Directory"),
			Description("The DirectoryWatchingEnabled determines if files and subdirectories list is automatically uptadated.")
		]
		public bool DirectoryWatchingEnabled
		{
			set
			{
				wartownik.EnableRaisingEvents = value;
				if (wartownik.EnableRaisingEvents) PobierzZawartoscKatalogu();

			}
			get
			{
				return wartownik.EnableRaisingEvents;
			}
		}
		#endregion

		#region Zdarzenia
		private void listBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			this.OnClick(e);
			this.OnSelectedFileChanged(sender,e);
		}

		//Zdarzenie SelectedFileChanged
		//1. deklaracja typu metody zdarzeniowej
		public delegate void SelectedFileChangedEventHandler(object sender,System.EventArgs e); //deklaracja typu metody zdarzeniowej
		//2. deklaracja zdarzenia i opis do niej w atrybucie
		/// <summary>
		/// Occures when file selectecion is changed.
		/// </summary>
		/// <seealso cref="FileName"></seealso>
		/// <seealso cref="OnSelectedFileChanged"></seealso>
		/// <seealso cref="SelectedFileChangedEventHandler"></seealso>
		[
			Category("Directory"),
			Description("Occures when file selectecion is changed.")
		]
		public event SelectedFileChangedEventHandler SelectedFileChanged;
		//3. pomocnicza metoda wywolujaca (launch method)
		protected virtual void OnSelectedFileChanged(object sender,System.EventArgs e)
		{
			//koniecznie trzeba sprawdzic, czy ze zdarzeniem jest w ogole zwiazana jakas metoda
			if (SelectedFileChanged!=null) SelectedFileChanged(this,e);
		}

		//Zdarzenie DirectoryPathChanged
		/// <summary>
		/// Occures when directory presented in component is changed.
		/// </summary>
		/// <seealso cref="DirectoryPath"></seealso>
		/// <seealso cref="OnDirectoryPathChanged"></seealso>
		/// <seealso cref="SelectedFileChangedEventHandler"></seealso>
		[
			Category("Directory"),
			Description("Occures when directory presented in component is changed.")
		]
		public event SelectedFileChangedEventHandler DirectoryPathChanged;
		protected virtual void OnDirectoryPathChanged(object sender,System.EventArgs e)
		{
			if (DirectoryPathChanged!=null) DirectoryPathChanged(this,e);
		}

		//Zdarzenie FileDoubleClicked
		public delegate void FileDoubleClickedEventHandler(object sender,System.EventArgs e,string fileName);
		/// <summary>
		/// Occures when one of the files in the list is double clicked.
		/// </summary>
		/// <seealso cref="OnFileDoubleClicked"></seealso>
		/// <seealso cref="FileDoubleClickedEventHandler"></seealso>
		[
			Category("Directory"),
			Description("Occures when one of the files in the list is double clicked.")
		]
		public event FileDoubleClickedEventHandler FileDoubleClicked;
		protected virtual void OnFileDoubleClicked(object sender,System.EventArgs e,string fileName)
		{
			if (FileDoubleClicked!=null) FileDoubleClicked(this,e,fileName);
		}
		#endregion

		//nadpisanie metody Refresh
		/// <summary>
		/// Refreshes the content of the component including the directories and files list.
		/// </summary>
		public override void Refresh()
		{
			base.Refresh();
			PobierzZawartoscKatalogu();
		}


		//sledzenie zmian w prezentowanym katalogu
		private void UstawWartownika()
		{
			//nic nie robimy jezeli obiekt juz istnieje
			if (wartownik!=null) return;

			wartownik = new FileSystemWatcher();

			wartownik.Path = sciezkaKatalogu;

			//sledzone czynnosci
			wartownik.NotifyFilter = NotifyFilters.FileName | NotifyFilters.DirectoryName;

			//wiazanie zdarzen wartownika z metoda Refresh
			wartownik.Changed += new FileSystemEventHandler(PrzyZmianie);
			wartownik.Created += new FileSystemEventHandler(PrzyZmianie);
			wartownik.Deleted += new FileSystemEventHandler(PrzyZmianie);
			wartownik.Renamed += new RenamedEventHandler(PrzyZmianie_Renamed);

			//aktywacja obserwowania
			wartownik.EnableRaisingEvents = true;
		}

		//wywolujace metody pomocnicza
		private void PrzyZmianie(object source, FileSystemEventArgs e)
		{
			this.PobierzZawartoscKatalogu();
		}
		private void PrzyZmianie_Renamed(object source, RenamedEventArgs e)
		{
			this.PobierzZawartoscKatalogu();
		}

		//listBox1_MouseDown, listBox1_MouseUp i listBox1_MouseMove sa w bloku drag'n'drop

		private void listBox1_MouseEnter(object sender, System.EventArgs e)
		{
			this.OnMouseEnter(e);
		}

		private void listBox1_MouseHover(object sender, System.EventArgs e)
		{
			this.OnMouseHover(e);
		}

		private void listBox1_MouseLeave(object sender, System.EventArgs e)
		{
			this.OnMouseLeave(e);
		}

		private void listBox1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			this.OnKeyDown(e);
		}

		private void listBox1_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			this.OnKeyPress(e);
		}

		private void listBox1_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			this.OnKeyUp(e);
		}

		/// <summary>
		/// Indicates if the list box is to be single-select, multi-select, or unselectable.
		/// </summary>
		[
			Category("Behavior"),
			Description("Indicates if the list box is to be single-select, multi-select, or unselectable.")
		]
		public SelectionMode SelectionMode
		{
			set
			{
				listBox1.SelectionMode = value;
			}
			get
			{
				return listBox1.SelectionMode;
			}
		}


		#region drag'n'drop
		//wlasnosc StartDragAutomatically
		private bool startDragAutomatically=false;
		/// <summary>
		/// Determines if the drag'n'drop process begin automatically after dragging element for number of pixels determined by <see cref="DragDistance">DragDistance</see> property.
		/// </summary>
		/// <seealso cref="DragDistance">DragDistance</seealso>
		[
			Category("Drag Drop"),
			Description("Determines if the drag'n'drop process begin automatically after dragging element for number of pixels determined by DragDistance property.")
		]
		public bool StartDragAutomatically
		{
			set
			{
				startDragAutomatically = value;
			}
			get
			{
				return startDragAutomatically;
			}
		}

		//wlasnosc DragDistance
		private int dragDistance=5;
		/// <summary>
		/// Gets or sets the distance item must be dragged with mouse to begin drag'n'drop process (if <see href="StartDragAutomatically">StartDragAutomatically</see> is set to true).
		/// </summary>
		/// <seealso cref="MouseDrag"></seealso>
		/// <seealso cref="StartDrag"></seealso>
		[
			Category("Drag Drop"),
			Description("Determines the distance the item must be dragged with mouse to begin drag'n'drop process (if StartDragAutomatically is set to true).")
		]
		public int DragDistance
		{
			set
			{
				dragDistance = value;
			}
			get
			{
				return dragDistance;
			}
		}

		//metody i pola zwiazane z obsluga automatycznego uruchomienia drag'n'drop po przesunieciu o 5 pixeli
		private bool mouseClicked=false;
		private Point mouseClickedPos;

		private void listBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			//przekazanie zdarzenia z listBox1 do FileListBox
			this.OnMouseDown(e);

			//zwiazane z drag'n'drop
			if (e.Button==MouseButtons.Left && System.IO.File.Exists(this.FileName))
				{
				mouseClicked=true;
				mouseClickedPos=new Point(e.X,e.Y);
				}
		}

		private void listBox1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			//przekazanie zdarzenia z listBox1 do FileListBox
			this.OnMouseUp(e);

			//zwiazane z drag'n'drop
			mouseClicked=false;
		}

		private void listBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			//przekazanie zdarzenia z listBox1 do FileListBox
			this.OnMouseMove(e);

			//zwiazane z drag'n'drop
			if (mouseClicked)
				{
				int dx=e.X-mouseClickedPos.X;
				int dy=e.Y-mouseClickedPos.Y;
				double distance=Math.Sqrt(dx*dx+dy*dy);
				if (distance>=dragDistance)
					{
					this.OnMouseDrag(sender,e);
					if (startDragAutomatically)
						{
						this.OnStartDrag(sender,e,this.FileName);
						this.DoDragDrop(this.FileName,DragDropEffects.Copy);
						}
					mouseClicked=false;
					}
				}
		}

		//definicja zdarzenia MouseDrag
		/// <summary>
		/// Occures when the mouse is moved number of pixels determined by <b>DragDistance</b> with left button pressed.
		/// </summary>
		[
			Category("Mouse"),
			Description("Occures when the mouse is moved number of pixels determined by DragDistance with left button pressed.")
		]
		public event MouseEventHandler MouseDrag;
		protected virtual void OnMouseDrag(object sender,System.Windows.Forms.MouseEventArgs e)
		{
			if (MouseDrag!=null) MouseDrag(this,e);
		}

		//definicja zdarzenia StartDrag
		/// <summary>
		/// Occures when user has begun to drag the file in the list.
		/// </summary>
		[
			Category("Drag Drop"),
			Description("Occures when user has begun to drag the file in the list.")
		]
		public event FileDoubleClickedEventHandler StartDrag;
		protected virtual void OnStartDrag(object sender,System.EventArgs e,string fileName)
		{
			if (StartDrag!=null) StartDrag(this,e,fileName);
		}
		#endregion
	}
}
